package dds.control.simulator;

import org.w3c.dom.Document;

import dds.control.ResourceType;
import dds.control.XMLLoader;

/**
 * The MapGenerator class.
 * 
 * @author ???
 */
// TODO Comment MapGenerator.
public final class MapGenerator {

    /**
     * The mapGen.
     */
    private static MapGenerator mapGen = new MapGenerator();

    /**
     * The getMapGen.
     * 
     * @return The singleton MapGenerator.
     */
    public static MapGenerator getMapGen() {
        return mapGen;
    } // end method getMapGen()

    /**
     * The simulationMap.
     */
    private transient Document simulationMap;

    /**
     * Constructor for MapGenerator.
     */
    private MapGenerator() {
        // TODO: Even though this will now allow the appropriate schema to be
        // loaded independently of the schema definition in the xml (maybe?) it
        // does NOT seem to be recognizing errors in the xml.
        super();
    } // end constructor MapGenerator()

    /**
     * Getter for simulationMap.
     * 
     * @return the simulationMap
     */
    public Document getSimulationMap() {
        return simulationMap;
    } // end method getSimulationMap()

    /**
     * The loadMap.
     * 
     * @param fileName Location of map file to load.
     * @return success indicates if the map was successfully loaded or not.
     */
    public Document loadMap(final String fileName) {
        this.simulationMap = XMLLoader.getLoader().loadXML(fileName,
                ResourceType.MAP);
        return this.simulationMap;
    }

}
