package dds.control.simulator.ai;

import java.lang.reflect.TypeVariable;

/**
 * The AIParameter class.
 * 
 * @author jbolton
 */
public class AIParameter {

    /**
     * The name.
     */
    private String name;

    /**
     * The value.
     */
    private String value;

    /**
     * Getter for name.
     * 
     * @return the name
     */
    public final String getName() {
        return name;
    }

    /**
     * Setter for name.
     * 
     * @param nameStr the name to set
     */
    public final void setName(final String nameStr) {
        this.name = nameStr;
    }

    /**
     * Getter for value.
     * 
     * @return the value
     */
    public final String getValue() {
        return value;
    }

    /**
     * Setter for value.
     * 
     * @param val the value to set
     */
    public final void setValue(final String val) {
        this.value = val;
    }

    /**
     * The evaluateAs.
     * 
     * @param type Type of object to return as.
     * @return An Object of the specified type.
     */
    public final Object evaluateAs(final TypeVariable type) {
        return null;
    }

    /**
     * Constructor for AIParameter.
     * 
     * @param nameStr The param name.
     * @param val The param value.
     */
    public AIParameter(final String nameStr, final String val) {
        super();
        this.name = nameStr;
        this.value = val;
    }
    
    /**
     * The toString.
     * @return a string containing the name and value of this AIParameter.
     * @see java.lang.Object#toString()
     */
    public final String toString() {
        return "AIParameter name: " + name + " value: " + value;
    }
}
