package dds.control.simulator.ai.commands;

import bsh.CallStack;
import bsh.Interpreter;
import dds.control.simulator.SimController;

/**
 * The RemoveSimObject class.
 * 
 * @author Mike Sanders
 */
public final class RemoveSimObject {

    /**
     * Constructor for RemoveSimObject.
     */
    private RemoveSimObject() {
        super();
    } // end constructor()

    /**
     * The invoke method is called to execute this command.
     * 
     * @param env is the Interpreter environment that the command is executed
     *            in.
     * @param callstack is the CallStack of the environment.
     * @param idString is a String representing the idString of the object to be
     *            removed from the Simulation.
     */
    public static void invoke(final Interpreter env, final CallStack callstack,
            final String idString) {

        SimController.getSimControl().getSimulation().removeDynamicObject(
                idString);        

    } // end method invoke()

} // end class definition RemoveSimObject
