/**
 * SimObjectUpdate.java.
 */
package dds.model.simulation;

/**
 * The SimObjectUpdate enum is responsible for representing the different
 * changes to SimObjects that occur within the Simulation and need to be
 * reflected in the view.
 * 
 * @author Jacob Bolton
 */
public enum SimObjectUpdate {
    /**
     * The POSITION enumeration represents a change in a SimObject's position.
     */
    POSITION,

    /**
     * The ORIENTATION enumeration represents a change in a SimObject's
     * orientation.
     */
    ORIENTATION,

    /**
     * The UPVECTOR enumeration represents a change in a SimObject's upwards
     * vector.
     */
    UPVECTOR;
}
