package dds.model.simulation;

import java.util.List;

/**
 * The TrafficLight class is responsible for modelling a traffic light within
 * the context of a Simulation.
 * 
 * @author Jacob Bolton
 */
public class TrafficLight extends AbstractDynamicObject {
    /**
     * Constructor for TrafficLight.
     * 
     * @param idString The UNIQUE ID for this object within the simulation.
     */
    public TrafficLight(final String idString) {
        super(idString);
        // TODO Write constructor for TrafficLight.
    }

    /**
     * The lightDelay.
     */
    private int lightDelay;

    /**
     * Getter for lightDelay.
     * 
     * @return the lightDelay
     */
    public final int getLightDelay() {
        return lightDelay;
    }

    /**
     * Setter for lightDelay.
     * 
     * @param delay the lightDelay to set
     */
    public final void setLightDelay(final int delay) {
        this.lightDelay = delay;
    }

    /**
     * The simulate method is responsible for computing any change that this
     * object may experience during a specified amount time.
     * 
     * @param time The change in time to simulate.
     * @see dds.model.simulation.AbstractDynamicObject#simulate(float)
     */
    protected void simulate(final float time) {
        // TODO Write simulate for TrafficLight.
    }

    /**
     * The destruct method is responsible for unlinking all of this object's
     * references to make garbage collection easier.
     * 
     * @see dds.model.simulation.AbstractSimObject#destruct()
     */
    protected final void destruct() {
        this.clearVerts();
    }

    /**
     * The detectCollision.
     * 
     * @param obj SimObject to detect collision against.
     * @return True on collision.
     * @see dds.model.simulation.AbstractSimObject
     *      #detectCollision(dds.model.simulation.AbstractSimObject)
     */
    // TODO Comment detectCollision in TrafficLight.
    protected final boolean detectCollision(final AbstractSimObject obj) {
        // TODO Write detectCollision for TrafficLight.
        return false;
    }

    /**
     * The handleCollision.
     * 
     * @param obj The obj.
     * @param data The data.
     * @see dds.model.simulation.AbstractSimObject
     *      #handleCollision(dds.model.simulation.AbstractSimObject,
     *      java.lang.Object)
     */
    // TODO Comment handleCollision in TrafficLight.
    protected final void handleCollision(final AbstractSimObject obj,
            final Object data) {
        // TODO Write handleCollision for TrafficLight.
    }

    /**
     * The computePolyLoop.
     * 
     * @see dds.model.simulation.AbstractSimObject#computePolyLoop()
     */
    // TODO Comment computePolyLoop in TrafficLight.
    protected final void computePolyLoop() {
        // TODO Write computePolyLoop for TrafficLight.
    }

    /**
     * The clearOtherVerts.
     * 
     * @see dds.model.simulation.AbstractSimObject#clearOtherVerts()
     */
    // TODO Comment clearOtherVerts in TrafficLight.
    @Override
    protected void clearOtherVerts() {
        // TODO Write clearOtherVerts for TrafficLight.

    }

    /**
     * The myCalculateVerts.
     * 
     * @see dds.model.simulation.AbstractSimObject#myCalculateVerts()
     */
    // TODO Comment myCalculateVerts in TrafficLight.
    @Override
    protected void myCalculateVerts() {
        // TODO Write myCalculateVerts for TrafficLight.

    }

    /**
     * The getBoundingVerts method returns a List of verts that inscribe the
     * bounding of this object.
     * 
     * @return The List of bounding verts.
     * @see dds.model.simulation.AbstractSimObject#getBoundingVerts()
     */
    @Override
    public final List<Vector3D> getBoundingVerts() {
        // TODO This needs to be written. I was going to use the object's
        // SmartPolygon, but apparently that only uses global coordinates and
        // doesn't yield information easily.
        return null;
    }

}
