package dds.model.trapeditor;

import processing.core.PGraphics;

/**
 * The RNode2D class represents a road node in 2D.
 * 
 * @author cyberdan
 */
public class RNode2D extends TNode2D {

    /**
     * The intA is the name of the starting intersection.
     */
    private String intA = null;

    /**
     * The intB is the name of the ending intersection.
     */
    private String intB = null;

    /**
     * Constructor for RNode2D. Just initializes the coordinate arrays.
     */
    public RNode2D() {
        // TODO Make sure there's a super() defined in TNode2D
        super();
        this.setNpoints(2);
        this.setXcors(new float[2]);
        this.setYcors(new float[2]);
    }

    /**
     * The toString.
     * 
     * @return A String representation of this object.
     * @see java.lang.Object#toString()
     */
    public final String toString() {
        return ("RNode2D: " + this.getName() + ": " + super.toString());
    }

    /**
     * The getIntA is the accessor for intA.
     * 
     * @return intA
     */
    public final String getIntA() {
        return intA;
    }

    /**
     * The setIntA is the modifier for intA.
     * 
     * @param intersectionStr the new intA
     */
    public final void setIntA(final String intersectionStr) {
        this.intA = intersectionStr;
    }

    /**
     * The getIntB is the accessor for intB.
     * 
     * @return intB
     */
    public final String getIntB() {
        return intB;
    }

    /**
     * The setIntB is the modifier for intB.
     * 
     * @param intersectionStr the new intB
     */
    public final void setIntB(final String intersectionStr) {
        this.intB = intersectionStr;
    }

    /**
     * The inBounds method determines if the point (x, y) is contained in the
     * region defined by this TNode2D.
     * 
     * @param xCoord the x-coordinate
     * @param yCoord the y-coordinate
     * @return true if in bounds; false otherwise
     */
    public final boolean inBounds(final int xCoord, final int yCoord) {
        // TODO Does this really ALWAYS return false.
        return false;
    }

    /**
     * The drawNode method draws the child object's node. A node can represent
     * an intersection, road, or block.
     * 
     * @param context the graphics context
     */
    @Override
    public final void drawNode(final PGraphics context) {
        context.stroke(0xffa90000);
        context.strokeWeight(3.5f);

        context.beginShape(PGraphics.LINES);
        context.vertex(getXcors()[0], getYcors()[0]);
        context.vertex(getXcors()[1], getYcors()[1]);
        context.endShape();
    }
}
