package dds.view.simulation.renderers;

import saito.objloader.OBJModel;
import dds.control.DDSApplet;
import dds.model.simulation.AbstractSimObject;
import dds.model.simulation.GenericMovableObject;
import dds.view.simulation.AbstractMovableObjectRenderer;

/**
 * The GenericMovableRenderer class is responsible for rendering a
 * GenericMoveable SimObject onto the screen.
 * 
 * @author Jacob Bolton
 * @author cyberdan
 */
public class GenericMovableRenderer extends AbstractMovableObjectRenderer {

    /**
     * The model.
     */
    private OBJModel model;

    /**
     * Getter for model.
     * 
     * @return the model
     */
    public final OBJModel getModel() {
        return model;
    }

    /**
     * Setter for model.
     * 
     * @param objmodel the model to set
     */
    public final void setModel(final OBJModel objmodel) {
        this.model = objmodel;
    }

    /**
     * The updateFromSim method handles updates coming from within the
     * simulation. Based on the update argument it will appropriately update the
     * view for the change in the model.
     * 
     * @param arg The argument for the update.
     * @see dds.view.simulation.AbstractSimObjectRenderer
     *      #updateFromSim(java.lang.Object)
     */
    public void updateFromSim(final Object arg) {
        // TODO Write updateFromSim in GenericMoveableRenderer.
    }

    /**
     * Constructor for GenericMovableRenderer.
     * 
     * @param obj The GenericMovableObject that this will render.
     */
    public GenericMovableRenderer(final GenericMovableObject obj) {
        super(obj);
        this.setModel(obj.getModel3D());
    }

    /**
     * Constructor for GenericMovableRenderer.
     * 
     * @param obj The GenericMovableObject that this will render.
     */
    public GenericMovableRenderer(final AbstractSimObject obj) {
        this((GenericMovableObject) obj);
    }

    /**
     * Getter for viewState.
     * 
     * @return the viewState
     * @see dds.view.simulation.AbstractDynamicObjectRenderer#getViewState()
     */
    public final Object getViewState() {
        // TODO Write getViewState in GenericMoveableRenderer.
        return null;
    }

    /**
     * Setter for viewState.
     * 
     * @param stateobj the viewState to set
     * @see dds.view.simulation.AbstractDynamicObjectRenderer
     *      #setViewState(java.lang.Object)
     */
    public final void setViewState(final Object stateobj) {
        // TODO Write setViewState in GenericMoveableRenderer.
    }

    /**
     * The interpolate method handles making changes to this renderer's
     * positional data based on the last known motion data for this moveable
     * object. This will hopefully compensate for some lag that may occur
     * between updates from the model and the view.
     * 
     * @param time The time change since last draw.
     * @see dds.view.simulation.AbstractMovableObjectRenderer#interpolate(float)
     */
    public void interpolate(final float time) {
        // TODO Write interpolate in GenericMoveableRenderer.
    }

    /**
     * The drawModel method draws JUST the model to the screen in local
     * coordinates. The drawOn() method should have performed the appropriate
     * transforms for this to work.
     * 
     * @param applet The DDSApplet to draw onto.
     * @see dds.view.simulation.AbstractSimObjectRenderer
     *      #drawModel(dds.control.DDSApplet)
     */
    @Override
    public final void drawModel(final DDSApplet applet) {
        // TODO Write drawModel in GenericMoveableRenderer.
    }

    /**
     * The applyOrientation method handles the use of an object's orientation
     * during rendering. Since not all objects need their orientation handled,
     * not all renderers will use a significant implementation of this.
     * 
     * @param applet The DDSApplet to draw onto.
     * @see dds.view.simulation.AbstractSimObjectRenderer
     *      #applyOrientation(dds.control.DDSApplet)
     */
    @Override
    public final void applyOrientation(final DDSApplet applet) {
        // TODO Write applyOrientation in GenericMoveableRenderer.

    }
}
