/**
 * GenericVehicleRenderer.java.
 */
package dds.view.simulation.renderers;

import dds.control.DDSApplet;
import dds.model.simulation.AbstractSimObject;
import dds.model.simulation.GenericObjectInterface;
import dds.model.simulation.GenericVehicle;
import dds.view.simulation.AbstractVehicleRenderer;

/**
 * The GenericVehicleRenderer class.
 * 
 * @author gte189u
 */
public class GenericVehicleRenderer extends AbstractVehicleRenderer {

    /**
     * The genericRenderer.
     */
    private GenericObjectRenderer genericRenderer;

    /**
     * Constructor for GenericVehicleRenderer.
     * 
     * @param obj The object to be responsible for rendering.
     */
    public GenericVehicleRenderer(final GenericVehicle obj) {
        super(obj);
        this.genericRenderer = new GenericObjectRenderer(
                (GenericObjectInterface) obj);
    }

    /**
     * The drawOn.
     * 
     * @param applet The applet to draw onto.
     * @see dds.view.RenderableContext#drawOn(dds.control.DDSApplet)
     */
    public final void drawModel(final DDSApplet applet) {
        this.genericRenderer.drawModel(applet);
        this.drawSpeedometer(applet);
        this.drawAccelometer(applet);
    }

    /**
     * Constructor for GenericVehicleRenderer.
     * 
     * @param obj The object to be responsible for rendering.
     */
    public GenericVehicleRenderer(final AbstractSimObject obj) {
        this((GenericVehicle) obj);
    }

    /**
     * Getter for genericRenderer.
     * 
     * @return the genericRenderer
     */
    public final GenericObjectRenderer getGenericRenderer() {
        return genericRenderer;
    }

    /**
     * Setter for genericRenderer.
     * 
     * @param renderer the genericRenderer to set
     */
    public final void setGenericRenderer(final GenericObjectRenderer renderer) {
        this.genericRenderer = renderer;
    }

    /**
     * Getter for viewState.
     * 
     * @return the viewState
     * @see dds.view.simulation.AbstractDynamicObjectRenderer#getViewState()
     */
    @Override
    public final Object getViewState() {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * Setter for viewState.
     * 
     * @param stateobj the viewState to set
     * @see dds.view.simulation.AbstractDynamicObjectRenderer
     *      #setViewState(java.lang.Object)
     */
    @Override
    public final void setViewState(final Object stateobj) {
        // TODO Auto-generated method stub

    }
}
