package dds.view.simulation.renderers;

import java.util.ArrayList;
import java.util.Collection;

import dds.control.DDSApplet;
import dds.model.simulation.AbstractSimObject;
import dds.model.simulation.TrafficLight;
import dds.model.simulation.Vector3D;
import dds.view.simulation.AbstractDynamicObjectRenderer;

/**
 * The TrafficLightRenderer class is responsible for drawing a TrafficLight from
 * the Simulation onto the screen.
 * 
 * @author Jacob Bolton
 * @author cyberdan
 */
public class TrafficLightRenderer extends AbstractDynamicObjectRenderer {

    /**
     * The verts.
     */
    private Collection verts;

    /**
     * Getter for verts.
     * 
     * @return the verts
     */
    public final Collection getVerts() {
        return verts;
    }

    /**
     * Setter for verts.
     * 
     * @param vertices the verts to set
     */
    public final void setVerts(final Collection vertices) {
        this.verts = vertices;
    }

    /**
     * The updateFromSim method handles updates coming from within the
     * simulation. Based on the update argument it will appropriately update the
     * view for the change in the model.
     * 
     * @param arg The argument for the update.
     * @see dds.view.simulation.AbstractSimObjectRenderer
     *      #updateFromSim(java.lang.Object)
     */
    public void updateFromSim(final Object arg) {
        // TODO Write updateFromSim
    }

    /**
     * Constructor for TrafficLightRenderer.
     * 
     * @param obj The TrafficLight that this will render.
     */
    public TrafficLightRenderer(final TrafficLight obj) {
        super(obj);
        this.verts = new ArrayList<Vector3D>();
    }

    /**
     * Constructor for TrafficLightRenderer.
     * 
     * @param obj The TrafficLight that this will render.
     */
    public TrafficLightRenderer(final AbstractSimObject obj) {
        this((TrafficLight) obj);
    }

    /**
     * Getter for viewState.
     * 
     * @return the viewState
     * @see dds.view.simulation.AbstractDynamicObjectRenderer#getViewState()
     */
    public final Object getViewState() {
        // TODO Write getViewState.
        return null;
    }

    /**
     * Setter for viewState.
     * 
     * @param stateobj the viewState to set
     * @see dds.view.simulation.AbstractDynamicObjectRenderer
     *      #setViewState(java.lang.Object)
     */
    public final void setViewState(final Object stateobj) {
        // TODO Write setViewState
    }

    /**
     * The drawModel method draws JUST the model to the screen in local
     * coordinates. The drawOn() method should have performed the appropriate
     * transforms for this to work.
     * 
     * @param applet The DDSApplet to draw onto.
     * @see dds.view.simulation.AbstractSimObjectRenderer
     *      #drawModel(dds.control.DDSApplet)
     */
    public final void drawModel(final DDSApplet applet) {
        // TODO Write drawModel
    }

    /**
     * The applyOrientation method handles the use of an object's orientation
     * during rendering. Since not all objects need their orientation handled,
     * not all renderers will use a significant implementation of this.
     * 
     * @param applet The DDSApplet to draw onto.
     * @see dds.view.simulation.AbstractSimObjectRenderer
     *      #applyOrientation(dds.control.DDSApplet)
     */
    @Override
    public void applyOrientation(final DDSApplet applet) {
        // TODO Write applyOrientation
    }
}
